#ifndef FINALSOLUTION_H
#define FINALSOLUTION_H

#include <stdio.h>
#include <netdb.h>

#include <Constants.h>
#include <Interface.h>
#include <PasswdGen.h>
#include <Protocol.h>

using namespace std;


typedef struct
{
	pwdnum quot;
	pwdnum rem;
} pwdnumdiv_t;


pwdnumdiv_t pwdnumdiv(pwdnum num, pwdnum den);
void *CheckerThread(void *ptr);


class FinalSolution
{
	public:
	FinalSolution();
	~FinalSolution();

	void SetupCrack(
		Protocol myproto,
		ProtocolParams *myparams,
		PasswdGen *mypwg,
		int mythreads);
	void StartCrack();
	void PauseCrack();
	char *GetPassword();

	friend void *CheckerThread(void *ptr);
	friend class TextInterface;
	friend class ProtocolChecker;
	friend class FTPProtocolChecker;

	private:
	Protocol proto;
	ProtocolParams *params;
	PasswdGen *pwg;
	int threads;
	int free_threads;
	pthread_mutex_t mutex;

	bool initialized;
	bool started;
	bool hostchecked;
	bool nomorepasswds;
	bool passwordfound;
	char password[BIGGEST_PASSWORD];

	struct hostent *h;

	TextInterface textiface;

	void ThreadFinished(
		ConnectionResult result,
		char mypassword[BIGGEST_PASSWORD]);
};


void SetFinalSolution(FinalSolution *myfs);
FinalSolution *GetFinalSolution();

#endif

