#ifndef PROTOCOL_H
#define PROTOCOL_H

#include <pthread.h>
#include <Constants.h>

using namespace std;


typedef enum {FTP, POP3} Protocol;


typedef enum
{
	Login,					// Yeah! We did it :^D
	PasswordIncorrect,		// Try another password :^(
	NoMorePasswds,			// Try another crack method!!
	UserIncorrect,			// Is the user valid?
	HostNotFound,			// Oops!
	ConnectionRefused,		// The port was closed
	TimeOut,				// Connection timeout
	NotInitialized			// You didn't setup anything
} ConnectionResult;


class ProtocolParams
{
	public:
	char host[HOST_LENGTH];
	int port;
};


class ProtocolChecker
{
	public:
	ProtocolChecker();
	~ProtocolChecker();

	void Setup(ProtocolParams *myparams);
	// Override this!!
	virtual ConnectionResult Try(char password[BIGGEST_PASSWORD]);
	
	protected:
	ProtocolParams *params;
};


class FTPProtocolParams : public ProtocolParams
{
	public:
	char user[FTP_BIGGEST_USER];
};


class FTPProtocolChecker : public ProtocolChecker
{
	public:
	FTPProtocolChecker();
	~FTPProtocolChecker();

	ConnectionResult Try(char password[BIGGEST_PASSWORD]);
	
	private:
	pthread_mutex_t mutex;
};

#endif

