#ifndef SESSION_H
#define SESSION_H

#include <Constants.h>
#include <PasswdGen.h>

#define	MAGICBYTES		"FS00000000"

#define	VERSION_0_2		0002

#define PROTOCOL_FTP	0
#define	PROTOCOL_POP3	1

#define	METHOD_BF		0
#define METHOD_DICT		1

#define BF_RANGE_NUM	0
#define BF_RANGE_ALPHA	1
#define BF_RANGE_ALPHAN	2

/*
 *  The header format shall remain unchanged from version to version
 *
 *
 *  About the SessionFile_header.version structure member:
 *
 *  0001 = 0.1
 *  0002 = 0.2
 *  0020 = 0.20
 *  0098 = 0.98
 *  0140 = 1.40
 *
 */

typedef struct
{
	char magicbytes[10];
	long int version;
} SessionFile_header;


typedef struct
{
	int protocol;
	int method;
	pwdnum range[2];		// range[0] = first password; range[1] = last pasword
	
	char host[HOST_LENGTH];
	int port;
	char user[SESSION_USER];
} SessionFile_body;


typedef struct
{
	int range;
	int maxlength;
} SessionFile_bfparams;


class Session
{
	public:
	Session();
	~Session();

	bool Read(char *myfilename);
	bool Write(char *myfilename);
	
	SessionFile_body data;
	SessionFile_bfparams bfparams;
};


#endif

