#include <stdio.h>
#include <iostream.h>

#include <Interface.h>
#include <FinalSolution.h>

TextInterface::TextInterface()
{
	total = partial = 0;
	pthread_mutex_init(&mutex, NULL);
}


TextInterface::~TextInterface()
{
}


int TextInterface::ExecInterface()
{
	FinalSolution *FS = GetFinalSolution();

	cout << "Crack resume:" << endl;
	cout << "Hostname: ";

	switch(FS->proto)
	{
		case FTP:
		cout << "ftp://" << FS->params->host << ":" << FS->params->port << "/" << endl;
		cout << "Username: " << ((FTPProtocolParams *)(FS->params))->user << endl;
		break;
		
		case POP3:
		cout << "pop3://" << FS->params->host << ":" << FS->params->port << "/" << endl;
		//cout << "Username: " << pop3_username << endl;
		break;
	}

	cout << "Threads: " << FS->threads << endl;
	cout << "Crack method: " << FS->pwg->Type() << endl;

	if(strcmp(FS->pwg->Type(), "Bruteforce") == 0)
	{
		cout << "Maximun password length: " << ((BruteForcePasswdGen *)(FS->pwg))->MaxLength() << endl;
		switch( ((BruteForcePasswdGen *)(FS->pwg))->Range() )
		{
			case numeric:
			cout << "Range: numeric" << endl;
			break;
			
			case alpha:
			cout << "Range: alpha" << endl;
			break;

			case alphanumeric:
			cout << "Range: alphanumeric" << endl;
			break;
		}
	}

	cout << "Passwords block: " << FS->pwg->GetFirst() << " to " << FS->pwg->GetLast() << endl;

	if(strcmp(FS->pwg->Type(), "Dictionary") == 0)
	{
		cout << "Dictionary file: " << ((DictionaryPasswdGen *)(FS->pwg))->Filename() << endl;
	}

	total = FS->pwg->TotalPasswds();
}


// Interface signals
void TextInterface::OnePasswdLess(char password[BIGGEST_PASSWORD])
{
	pthread_mutex_lock(&mutex);
	partial++;
	
	cout << "\n(" << ((partial * 100) / total) << "%)\t" << partial << " / " << total << " : " << "\"" << password << "\"";

/*	printf("\r(%d%%)\t%d / %d : \"%s\"",
		((partial*100)/total),
		partial,
		total,
		password);*/

	pthread_mutex_unlock(&mutex);
}


void TextInterface::FoundPasswd()
{
	// clean a little
	cout << endl << endl << endl;
	cout << "PASSWORD FOUND: '" << GetFinalSolution()->GetPassword()
		<< "'" << endl;
	cout << "Waiting all threads to finish..." << endl;
}


void TextInterface::UserIncorrect()
{
	cout << "User incorrect" << endl;
}


void TextInterface::CrackFinished()
{
	// Cleanup the line
	cout << "\r                                                  ";

	if(!GetFinalSolution()->passwordfound)
	{
		cout << "\rCrack finished. Password not found. Congratulations, your password is strong!" << endl;
	}
	else
	{
		cout << "\rCrack finished. Password found." << endl;
	}
}


void TextInterface::HostNotFound()
{
	cout << "Host not found" << endl;
}


void TextInterface::ConnectionRefused()
{
	cout << "Connection refused" << endl;
}


void TextInterface::TimeOut()
{
	cout << "Timeout" << endl;
}


void TextInterface::CouldNotConnect()
{
	cout << "Couldn't connect to remote host. Aborting..." << endl;
}

